#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    int num1, num2;
    cout << "Введите первое число для суммы: ";
    cin >> num1;
    cout << "Введите второе число для суммы: ";
    cin >> num2;

    // Сумма
    int sum_result = 0;
    int place = 1;

    while (num1 > 0 || num2 > 0) {
        int digit1 = num1 % 10;
        int digit2 = num2 % 10;

        int max_digit = max(digit1, digit2);
        sum_result += max_digit * place;

        num1 /= 10;
        num2 /= 10;
        place *= 10;
    }

    cout << "Сумма: " << sum_result << endl;
    int numm1, numm2;
    cout << "Введите первое число для произведения: ";
    cin >> numm1;
    cout << "Введите второе число для произведения: ";
    cin >> numm2;
    num1 = numm1;
    num2 = numm2;

    vector<int> intermediate_results;  // Вектор для промежуточных результатов
    int place_prod = 1;

    // Умножаем числа
    while (num2 > 0) {
        int digit2 = num2 % 10;
        int intermediate_result = 0;
        int place = 1;
        
        int temp_num1 = num1;  // Для сохранения исходного числа num1
        while (temp_num1 > 0) {
            int digit1 = temp_num1 % 10;
            int min_digit = min(digit1, digit2);
            intermediate_result += min_digit * place;
            temp_num1 /= 10;
            place *= 10;
        }

        intermediate_results.push_back(intermediate_result * place_prod);

        num2 /= 10;
        place_prod *= 10;
    }

    // Суммируем промежуточные результаты, выбирая наибольшие цифры для каждого разряда
    int final_result = 0;
    int max_size = 0;
    for (int res : intermediate_results) {
        max_size = max(max_size, (int)to_string(res).size());
    }

    for (int i = 0; i < max_size; ++i) {
        int max_digit = 0;
        for (int res : intermediate_results) {
            int digit = (res / (int)pow(10, i)) % 10;
            max_digit = max(max_digit, digit);
        }
        final_result += max_digit * (int)pow(10, i);
    }

    cout << "Произведение: " << final_result << endl;

    return 0;
}