#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>

using namespace std;

int main() {
    int num1, num2;

    cin >> num1;

    cin >> num2;
    int a = num1, b = num2;

    // Сумма
    int sum_result = 0;
    int place = 1;

    while (num1 > 0 || num2 > 0) {
        int digit1 = num1 % 10;
        int digit2 = num2 % 10;

        int max_digit = max(digit1, digit2);
        sum_result += max_digit * place;

        num1 /= 10;
        num2 /= 10;
        place *= 10;
    }

    cout << sum_result << endl;

    int numm1 = a, numm2 = b;

    vector<int> intermediate_results;  
    int place_prod = 1;

    while (numm2 > 0) {
        int digit2 = numm2 % 10;
        int intermediate_result = 0;
        int place = 1;
        
        int temp_numm1 = numm1;
        while (temp_numm1 > 0) {
            int digit1 = temp_numm1 % 10;
            int min_digit = min(digit1, digit2);
            intermediate_result += min_digit * place;
            temp_numm1 /= 10;
            place *= 10;
        }

        intermediate_results.push_back(intermediate_result * place_prod);

        numm2 /= 10;
        place_prod *= 10;
    }

   
    int final_result = 0;
    int max_size = 0;
    for (int res : intermediate_results) {
        max_size = max(max_size, (int)to_string(res).size());
    }

    for (int i = 0; i < max_size; ++i) {
        int max_digit = 0;
        for (int res : intermediate_results) {
            int digit = (res / (int)pow(10, i)) % 10;
            max_digit = max(max_digit, digit);
        }
        final_result += max_digit * (int)pow(10, i);
    }

    cout  << final_result << endl;

    return 0;
}